void main()
{
	vec3 Cin			= texture( InputTexture, TexCoord ).rgb ;
	float Gin			= Cin.g * 2.1 ;	//( Cin.g - ( 0.25 * 0.7 )) * 1.0 / 0.3 ;
	vec3 Cout ;
	ivec2 scrnDims		= textureSize( InputTexture, 0 );
	
	float ledge			= mix( vertex1.x, vertex2.x, 1.0 - ( TexCoord.y - vertex1.y ) / ( vertex2.y - vertex1.y ));
	float redge			= mix( vertex3.x, vertex4.x, 1.0 - ( TexCoord.y - vertex3.y ) / ( vertex4.y - vertex3.y ));
	
	if( TexCoord.x >= ledge &&
		TexCoord.x <= redge &&
		TexCoord.y >= min( vertex1.y, vertex3.y ) &&
		TexCoord.y <= max( vertex2.y, vertex4.y ))
	{
		if( Cin.g < 0.48 && min( Cin.r, Cin.b ) > 0.69 )
		{
			Cin.rb		-= 0.7 ;						//remove magenta (already reduced %10 by alpha)
			Cin.rb		*= 1.0 / 0.3 ;					//amplify remaining background content up to %100
			Cin.g		= ( Cin.r + Cin.b ) * 0.5 ;		//green adopts the average of red and blue
			
			float angle	= radians( fract( Gin ) * 360 );
			float xpos	= TexCoord.x + cos( angle ) * depth ;
			float ypos	= TexCoord.y + sin( angle ) * depth ;
			
			//do this better:
			if		( xpos < 0 ) xpos = TexCoord.x * 0.5 ;
			else if	( xpos > 1 ) xpos = TexCoord.x + ( 1.0 - TexCoord.x ) * 0.5 ;
			if		( ypos < 0 ) ypos = TexCoord.y * 0.5 ;
			else if	( ypos > 1 ) ypos = TexCoord.y + ( 1.0 - TexCoord.y ) * 0.5 ;
			
			vec3 C		= texelFetch( InputTexture, ivec2( vec2( xpos, ypos ) * scrnDims ), 0 ).rgb ;
			
			if( C.g < 0.48 && min( C.r, C.b ) > 0.69 )
			{
				C.rb	-= 0.7 ;
				C.rb	*= 1.0 / 0.3 ;
				C.g		*= 2.1 ;
				
				if( C.g < 0.48 && min( C.r, C.b ) > 0.69 ) C = vec3( Gin );
				else C.g = ( C.r + C.b ) * 0.5 ;
				
				Cout	= mix( Cin, C, alpha );
			}
			else if( reflect == 0 ) Cout = Cin ;
			else Cout	= mix( Cin, C, alpha );
		}
		else Cout		= Cin ;
	}
	else Cout			= Cin ;
	
	FragColor = vec4( Cout, 1.0 );
}